------------------------------------------------------------------------------
--                                                                          --
--                          PolyORB HI COMPONENTS                           --
--                                                                          --
--                P O H I C D R I V E R _ S P A C E W I R E                 --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                     Copyright (C) 2015 ESA & ISAE.                       --
--                                                                          --
-- PolyORB-HI is free software; you can redistribute it and/or modify under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 3,  or (at your option) any later ver- --
-- sion. PolyORB-HI is distributed in the hope that it will be useful, but  --
-- WITHOUT ANY WARRANTY; without even the implied warranty of               --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     --
--                                                                          --
-- As a special exception under Section 7 of GPL version 3, you are granted --
-- additional permissions described in the GCC Runtime Library Exception,   --
-- version 3.1, as published by the Free Software Foundation.               --
--                                                                          --
-- You should have received a copy of the GNU General Public License and    --
-- a copy of the GCC Runtime Library Exception along with this program;     --
-- see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    --
-- <http://www.gnu.org/licenses/>.                                          --
--                                                                          --
--              PolyORB-HI/Ada is maintained by the TASTE project           --
--                      (taste-users@lists.tuxfamily.org)                   --
--                                                                          --
------------------------------------------------------------------------------

pragma Style_Checks (Off); -- turn off style checks
-- Code automatically generated by asn1scc tool
-- Date was: 04/28/2011
-- Time was: 13:55:57

WITH Ada.Strings.Fixed;
USE ADA.Strings.Fixed;

WITH Interfaces;
USE Interfaces;

WITH Ada.Characters.latin_1;


WITH AdaAsn1RTL;
USE AdaAsn1RTL;

package POHICDRIVER_SPACEWIRE is


SUBTYPE Core_Frequence_T IS Asn1Int;

Core_Frequence_T_REQUIRED_BYTES_FOR_ENCODING:CONSTANT INTEGER := 4;
Core_Frequence_T_REQUIRED_BITS_FOR_ENCODING:CONSTANT INTEGER := 32;
Core_Frequence_T_REQUIRED_BYTES_FOR_ACN_ENCODING:CONSTANT INTEGER := 4;
Core_Frequence_T_REQUIRED_BITS_FOR_ACN_ENCODING:CONSTANT INTEGER := 32;

ERR_Core_Frequence_T:CONSTANT INTEGER := 1000; -- (0..4294967295) 



SUBTYPE Node_Addr_T IS Asn1Int;

Node_Addr_T_REQUIRED_BYTES_FOR_ENCODING:CONSTANT INTEGER := 1;
Node_Addr_T_REQUIRED_BITS_FOR_ENCODING:CONSTANT INTEGER := 8;
Node_Addr_T_REQUIRED_BYTES_FOR_ACN_ENCODING:CONSTANT INTEGER := 1;
Node_Addr_T_REQUIRED_BITS_FOR_ACN_ENCODING:CONSTANT INTEGER := 8;

ERR_Node_Addr_T:CONSTANT INTEGER := 1001; -- (0..255) 



SUBTYPE Clock_Division_T IS Asn1Int;

Clock_Division_T_REQUIRED_BYTES_FOR_ENCODING:CONSTANT INTEGER := 1;
Clock_Division_T_REQUIRED_BITS_FOR_ENCODING:CONSTANT INTEGER := 8;
Clock_Division_T_REQUIRED_BYTES_FOR_ACN_ENCODING:CONSTANT INTEGER := 1;
Clock_Division_T_REQUIRED_BITS_FOR_ACN_ENCODING:CONSTANT INTEGER := 8;

ERR_Clock_Division_T:CONSTANT INTEGER := 1002; -- (0..255) 



TYPE Spacewire_Conf_T_EXIST IS RECORD
	corefreq:BIT;
	clockdiv:BIT;
	remove_prot_id:BIT;
	rxblock:BIT;
	txblock:BIT;
END RECORD;
TYPE Spacewire_Conf_T IS RECORD
    devname : String(1..21);
    nodeaddr : Node_Addr_T:=0;
    corefreq : Core_Frequence_T:=0;
    clockdiv : Clock_Division_T:=0;
    remove_prot_id : Asn1Boolean;
    rxblock : Asn1Boolean;
    txblock : Asn1Boolean;
    Exist : Spacewire_Conf_T_EXIST;
END RECORD;

Spacewire_Conf_T_REQUIRED_BYTES_FOR_ENCODING:CONSTANT INTEGER := 26;
Spacewire_Conf_T_REQUIRED_BITS_FOR_ENCODING:CONSTANT INTEGER := 201;
Spacewire_Conf_T_REQUIRED_BYTES_FOR_ACN_ENCODING:CONSTANT INTEGER := 28;
Spacewire_Conf_T_REQUIRED_BITS_FOR_ACN_ENCODING:CONSTANT INTEGER := 221;

ERR_Spacewire_Conf_T_devname:CONSTANT INTEGER := 1003; -- (SIZE (1..20)) 




--END;
end POHICDRIVER_SPACEWIRE;
